module Functors where

{- Functors -}

data List a = Empty | a :| (List a) deriving (Eq, Show)
infixr 5 :|

mapL :: (a->b) -> List a -> List b
mapL _ Empty = Empty
mapL f (x:|xs) = f x :| (mapL f xs)

data MM a = N | J a deriving (Eq, Show)
mapMM :: (a->b) -> MM a -> MM b
mapMM _ N = N
mapMM f (J x) = J $ f x

data T a = Nil | Node (T a) a (T a) deriving (Eq, Show)
mapT :: (a->b) -> T a -> T b
mapT _ Nil = Nil
mapT f (Node l v r) = Node (mapT f l) (f v) (mapT f r)

-- mapL :: (a->b) -> List a -> List b
-- mapMM ::(a->b) -> MM a   -> MM b
-- mapT :: (a->b) -> T a    -> T b

--fmap :: (a->b) -> f a    -> f b
class Functor' f where
  fmap' :: (a->b) -> f a -> f b

instance Functor' List where
--   fmap' :: (a->b) -> List a -> List b
  fmap' = mapL

instance Functor' ((->)i) where
--   fmap' :: (a->b)-> ((->)i) a -> ((->)i) b
--   fmap' :: (a -> b) -> (i -> a) -> (i -> b)
  fmap' f g = f . g

-- fmap id = id
-- fmap id g = id . g = g
-- id g = g

-- (fmap f . fmap ff) == fmap (f.ff)
-- fmap (f.ff) g = (f.ff) . g = f ( ff ( g ))
-- (fmap f . fmap ff) g = fmap f (fmap ff g )
-- = fmap f (ff ( g )) = f (ff (g))

replaceWithA:: a -> Char
replaceWithA x = 'a'

lms = [Just "abc", Just "a", Nothing]
-- fmap replaceWithA lms
-- (fmap.fmap) replaceWithA lms
-- [Just 'a',Just 'a',Nothing]
-- (fmap.fmap.fmap) replaceWithA lms
-- [Just "aaa",Just "a",Nothing]
--lift2 :: (a->b->c) -> f a -> f b -> f c

class Functor' f => Applicative' f where
  pure' :: a-> f a
  (<*!*>) :: f (a->b) -> f a -> f b

-- instance Applicative' List where
--   pure
--   <*!*>

-- applicative []
-- applicative zipList
